/*
 * scanner.h -- SPL scanner interface
 */


#ifndef _SCANNER_H_
#define _SCANNER_H_


typedef struct {
  int line;
} NoVal;

typedef struct {
  int line;
  int val;
} IntVal;

typedef struct {
  int line;
  char *val;
} StringVal;

/*
if you have not yet written the parser, then you must have a menually written 
preliminary.h (and inlude it in scanner.l) where, among other things, the above typedefs 
are used: 

typedef union {
  NoVal noVal;
  IntVal intVal;
  StringVal stringVal;
} YYSTYPE;

if you have your parser, the content of preliminary.h will be created automatically and placed 
in parser.tab.h, which you must include. Additionally, the parser will define a variable 
yylval of type YYSTYPE. Set this variable in your scanner.l as fit for each pattern match. For 
those matchings with no value, set the NoVal part (just the line number), else set the IntVal 
resp. StringVal part.
*/


extern FILE *yyin;

int yylex(void);
 
 /* functionality to print textual representation of tokens not needed for the parser; so you 
   might comment the follwing out: */
void showToken(int token);

#endif /* _SCANNER_H_ */
